var apikey = null;
var apiversion = 'vnd.ddel.v1';
var isFocused = false;
var curEdit = {};
var curDevice = {};
var old = {};
var curRules = [];
var allGroups = [];
var allScenes = [];
var numberOfDevices = 0;
var allDeviceIds = [];
var zigBeeChannel = 0;
var UPDATE_DEVICES_INTERVAL = 1000;
var deviceNotFoundTimeout;
var countDownTimer;
var config;

if ('localStorage' in window) {
    if (localStorage.apikey) {
      apikey = localStorage.apikey;
    }
    else {
      localStorage.apikey = apikey;
    }
}

/**
 * Init touch and small displays.
 */
function devicesInit() {
    // check if this is mobile or desktop
    // and load custom js and css files
		
    if (Modernizr.touch) {	
        loadjscssfile("mobile.css", "css");
        isDesktop = false;
    }
    else {	
        isDesktop = true;
        loadjscssfile("desktop.css", "css");
    }

    if (Modernizr.touch) {
        clickevent = "touchend";
        pointerStart = "touchstart";
        pointerEnd = "touchend";
        pointerMove = "touchmove";
    }
}

/**
 * Init the base branding of the interface.
 */
function initBranding() {

    var customBrand = false;

    var navName = "Wireless Light";

    if (customBrand) {
        var navName = "CUSTOM <span style=\"position: relative; display: inline-block; bottom: 8px;\">&reg;</span>";
        var brand = '<span class="custom-brand">' + navName + '</span>';
        $(".navbar-inner .brand").html(brand);
    }
}
		
/**
* build the html page for a given Sensor Object.
*/
function buildSubPageForTap() {

	var rowtxt = '<div class="location span6" style="margin:0px; padding:15px 0;">';
    rowtxt += '<div class="row-fluid">';
	rowtxt += '<table align="center" border="0" style="width:90%">';
    rowtxt += '<tbody style="margin:0;padding:0;">';
	
	//name
	rowtxt += '<tr><td>Name</td><td colspan="2"><form class="inner-addon right-addon navbar-form pull-left"><img style="" class="glyphicon" src="img/pencil.png"></img><input id="devNameLabelBig" type="text" style="margin-left:0px;width:88%;" maxlength="32" value="' + curDevice.name + '"></form></td></tr>';
	
	rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
	//button assignment
	//4 buttons for Hue Tap
	
	//button 1
	rowtxt += '<tr class="buttonRow" id="0"><td><img src="img/hue-btn1-large.png" /></td><td style="white-space:normal;"><select class="selectFunction" id="selectFunction0" >';
	rowtxt += '<option value="1">All Lights Off</option><option value="2">All Lights On</option><option value="3">Group Off</option><option value="4">Group On</option><option value="5">Call Scene</option></select>';
	rowtxt += '<select class="selectTarget" id="selectTarget0" ></select></td></tr>';
	rowtxt += '<tr><td colspan="2">&nbsp;</td></tr>';
	
	//button 2
	rowtxt += '<tr class="buttonRow" id="1"><td><img src="img/hue-btn2-large.png" /></td><td style="white-space:normal;"><select class="selectFunction" id="selectFunction1" >';
	rowtxt += '<option value="1">All Lights Off</option><option value="2">All Lights On</option><option value="3">Group Off</option><option value="4">Group On</option><option value="5">Call Scene</option></select>';
	rowtxt += '<select class="selectTarget" id="selectTarget1" ></select></td></tr>';
	rowtxt += '<tr><td colspan="2">&nbsp;</td></tr>';
	
	//button 3
	rowtxt += '<tr class="buttonRow" id="2"><td><img src="img/hue-btn3-large.png" /></td><td style="white-space:normal;"><select class="selectFunction" id="selectFunction2" >';
	rowtxt += '<option value="1">All Lights Off</option><option value="2">All Lights On</option><option value="3">Group Off</option><option value="4">Group On</option><option value="5">Call Scene</option></select>';
	rowtxt += '<select class="selectTarget" id="selectTarget2" ></select></td></tr>';
	rowtxt += '<tr><td colspan="2">&nbsp;</td></tr>';
	
	//button 4
	rowtxt += '<tr class="buttonRow" id="3"><td><img src="img/hue-btn4-large.png" /></td><td style="white-space:normal;"><select class="selectFunction" id="selectFunction3" >';
	rowtxt += '<option value="1">All Lights Off</option><option value="2">All Lights On</option><option value="3">Group Off</option><option value="4">Group On</option><option value="5">Call Scene</option></select>';
	rowtxt += '<select class="selectTarget" id="selectTarget3" ></select></td></tr>';
	rowtxt += '<tr><td colspan="2">&nbsp;</td></tr>';
	
	//delete
	rowtxt += '<tr><td><span class="btn btn-danger deleteButton" style="margin: 15px 0px;">Delete</span></td>';
	
	//apply/done
	rowtxt += '<td colspan="2"align="right"><span class="btn btn-primary saveButton" style="margin: 15px 0px;">Apply</span>&nbsp;&nbsp;&nbsp;<span class="btn actionButton doneButton" style="margin: 15px 0px;">Cancel</span></td></tr>';

	rowtxt += '</tbody></table></div></div>';
	
	pageLightList.innerHTML = "";
    pageLightList.innerHTML += rowtxt;
	
	//select the current option for each button for hue tap
	for (r in curRules) {
		if ((curRules[r].actions[0].address).indexOf("/groups/0/") != -1) {
			if (curRules[r].actions[0].body.on == false) {
				$('#selectFunction'+r).val('1');
			} else {
				$('#selectFunction'+r).val('2');
			}
		} else if ((curRules[r].actions[0].address).indexOf("/scenes/") != -1) {
			$('#selectFunction'+r).val('5');
		} else {
			if (curRules[r].actions[0].body.on == false) {
				$('#selectFunction'+r).val('3');
			} else {
				$('#selectFunction'+r).val('4');
			}
		}
	}
	
	//fill the selects with groups and scenes
	$( ".selectFunction" ).each(function(i) {
		if (($('option:selected', this).val() == "1") || ($('option:selected', this).val() == "2")) {		
			$('#selectTarget'+i).html('<option value="0">&#10003;</option>');
		} else if (($('option:selected', this).val() == "3") || ($('option:selected', this).val() == "4")) {
			var a = curRules[i].actions[0].address;
			var curGroup = a.substring(a.indexOf("/groups/")+8,a.indexOf("/action"));
			if (allGroups.length === 0) {
				$('#selectTarget'+i).append("<option value=\"X\">No Group found</option>");
			} else {		
				for (option in allGroups) {
					$('#selectTarget'+i).append(allGroups[option]);
					$('#selectTarget'+i).val(curGroup);
				}
			}
		} else if ($('option:selected', this).val() == "5") {
			var a = curRules[i].actions[0].address;
			var curGroup = a.substring(a.indexOf("/groups/")+8,a.indexOf("/scenes"));
			var curScene = a.substring(a.indexOf("/scenes/")+8,a.indexOf("/recall"));
			
			if (allScenes.length === 0) {
				$('#selectTarget'+i).append("<option value=\"X\">No Scene found</option>");
			} else {
				for (option in allScenes) {
					$('#selectTarget'+i).append(allScenes[option]);
					$('#selectTarget'+i).val(curGroup + "-" + curScene);
				}
			}
		}
	});
	
	old.selectTarget0 = $('#selectTarget0').val();
	old.selectFunction0 = $('#selectFunction0').val();
	old.selectTarget1 = $('#selectTarget1').val();
	old.selectFunction1 = $('#selectFunction1').val();
	old.selectTarget2 = $('#selectTarget2').val();
	old.selectFunction2 = $('#selectFunction2').val();
	old.selectTarget3 = $('#selectTarget3').val();
	old.selectFunction3 = $('#selectFunction3').val();
	old.name = $('#devNameLabelBig').val();
}

/**
* build the html page for a given Sensor Object.
*/
function buildSubPageForSwitch() {

	var rowtxt = '<div class="location span6" style="margin:0px; padding:15px 0;">';
    rowtxt += '<div class="row-fluid">';
	rowtxt += '<table align="center" border="0" style="width:90%">';
    rowtxt += '<tbody style="margin:0;padding:0;">';
	
	//name
	rowtxt += '<tr><td>Name</td><td colspan="2"><form class="inner-addon right-addon navbar-form pull-left"><img style="" class="glyphicon" src="img/pencil.png"></img><input id="devNameLabelBig" type="text" style="margin-left:0px;width:88%;" maxlength="32" value="' + curDevice.name + '"></form></td></tr>';
	
	rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
	
	//picture
	rowtxt += '<tr><td colspan="3" align="center"><img src="img/zhaswitch3_big.png" style="width:90%;max-width:260px;" /></td></tr>';
	
	rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
	
	//model
	rowtxt += '<tr><td>Model</td><td colspan="2">' + curDevice.modelid + '</td></tr>';
	
	//swVersion
	rowtxt += '<tr><td>Version</td><td colspan="2">' + curDevice.swversion + '</td>';
	//rowtxt += '<td><button class="btn" id="fwUpdate-btn">Update<button></td>';
	rowtxt += '</tr>';
	
	//battery
	rowtxt += '<tr><td>Battery</td><td colspan="2">' + ' 100% ' + '</td></tr>';
	//group
	for (g in curDevice.groupIds) {
		rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
		rowtxt += '<tr><td>Group</td><td colspan="2"><span id="controlGroup">' + config.groups[curDevice.groupIds[g]].name + '</span></td></tr>';
	}
	
	rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
	
	rowtxt += '<tr><td style="white-space:normal" colspan="3"><span class="label label-info">Info</span> You can use the WebApp to add lights and scenes to the switch-group the same way like for other groups.</td></tr>';
	
	rowtxt += '<tr><td colspan="3">&nbsp;</td></tr>';
	
	//delete
	rowtxt += '<tr><td><span class="btn btn-danger deleteButton" style="margin: 15px 0px;">Delete</span></td>';
	
	//apply/done
	rowtxt += '<td colspan="2"align="right"><span class="btn btn-primary saveButton" style="margin: 15px 0px;">Apply</span>&nbsp;&nbsp;&nbsp;<span class="btn actionButton doneButton" style="margin: 15px 0px;">Cancel</span></td></tr>';

	rowtxt += '</tbody></table></div></div>';
	
	pageLightList.innerHTML = "";
    pageLightList.innerHTML += rowtxt;
	
	old.name = $('#devNameLabelBig').val();
	
}

/**
* adds html to the Devices index page.
*/
function showDevices(sensors) {   
    var device = {};
	var deviceIcon = "";
    var rowtxt="";	
	rowtxt += '<div class="location span6" style="margin-left:0px;">';
	rowtxt += '<div class="row-fluid">';
	rowtxt += '<table border="0" id="deviceTable">';
    rowtxt += '<tbody>';
	for(key in sensors) {
		device = sensors[key];
		if ((device.type === "ZGPSwitch" || device.type === "ZHASwitch") && device.modelid !== "FLS-NB1") {
			device.id = key;
			if (device.type === "ZGPSwitch") {
				deviceIcon = "<img src=\"img/huetap.png\">";
			} else if (device.type === "ZHASwitch") { 
				deviceIcon = "<img src=\"img/zhaswitch3_small.png\">";
			} else if (device.type === "ZHAPresence") {
				deviceIcon = "<img src=\"img/presence.png\">";
			} else if (device.type === "ZHALight") {
				deviceIcon = "<img src=\"img/light.png\">";
			}
			rowtxt += '<tr class="light_item" style=""><td style="width:12%">' + deviceIcon + '</td><td style="width:10px;"></td>';
			rowtxt += '<td>' + device.name + '</td>';
			rowtxt += '<td style="" class="edit_button" data-did="' + device.id + '"></td></tr>';
			rowtxt += "<tr><td colspan=\"4\">&nbsp;</td></tr>";
		}
	}
	rowtxt += '</tbody>';
    rowtxt += '</table>';
	if (Modernizr.localstorage && localStorage.getItem("de-gw-swVersion") != undefined) {
		var swVersion = localStorage.getItem("de-gw-swVersion");
		rowtxt += '<div class="button-toolbar pull-right" style="padding-top:20px;padding-bottom:10px;"><span class="btn btn-primary connect_btn">Connect a new Device</span>&nbsp;<a class="btn" href="/index.html?v=' + swVersion + '">Done</a></div>';
	} else {
		rowtxt += '<div class="button-toolbar pull-right" style="padding:20px 0px;"><span class="btn btn-primary connect_btn">Connect a new Device</span>&nbsp;<a class="btn" href="/index.html">Done</a></div>';
	}
	rowtxt += '</div>';
	rowtxt += '</div>';
	
	$("#pageLightList").html("");
	$("#pageLightList").html(rowtxt);

	adjustLightNames();
}


/**
 * Helper to adjust the size of the name field to not exceed the table size.
 */
function adjustLightNames() {
    $('.location').each(function(index) {
            var maxwidth = $(this).innerWidth() - 180;
            $('.light_item td:nth-child(3)').each(function(index) {
                $(this).css('max-width', maxwidth + 'px');
            });
    });
}

/**
* api/<apikey>/sensors
*/
function getDevices() {

    $.ajax({	
        url: 'api/' + apikey + '/sensors',
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: '',
        success: function(json, status, xhr) {		
			curEdit.obj = json;
			numberOfDevices = Object.keys(json).length; //only count devices which are supported?
			allDeviceIds = Object.keys(json);
			showDevices(curEdit.obj);		
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
              window.location.assign("/login.html");
              break;

            case 404: // not found go back
              window.location.assign("/");
              break;

            default:
              setTimeout(getDevices, 3000);
              showAlert('alert-error', '<b>Error!</b> Loading data, retry in three seconds ...');
              break;
            }
        },
		timeout: 10000
    });
}

/**
* Polling GW to get data on new connected devices
*/
function updateDevices() {
console.log("send REST API");
    $.ajax({	
        url: 'api/' + apikey + '/sensors',
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: '',
        success: function(json, status, xhr) {		
			if (numberOfDevices == Object.keys(json).length) {
				setTimeout(updateDevices, UPDATE_DEVICES_INTERVAL);
			} else if (numberOfDevices < Object.keys(json).length) {			
				for (id in Object.keys(json)) {
					var id = Object.keys(json)[id];
					if (!(_.contains(allDeviceIds, id))) {
						showAlert('alert-success', '<b>Ok!</b> Found a new device', '#deviceFoundInfo');
						clearTimeout(deviceNotFoundTimeout);
						deviceNotFoundTimeout = null;
						clearTimeout(countDownTimer);
						countDownTimer = null;
						if (json[id].modelid == "ZGPSWITCH") {
							createHueTapRules(json[id].uniqueid, id);
						}
					}
				}
				//TODO show success only when device is supported
			}	
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
              window.location.assign("/login.html");
              break;

            case 404: // not found go back
              window.location.assign("/");
              break;

            default:
              setTimeout(getDevices, 3000);
              showAlert('alert-error', '<b>Error!</b> Loading data, retry in three seconds ...');
              break;
            }
        },
		timeout: 10000
    });
}

/**
 * create rules for a Hue Tap
 * /params uniqueid of sensor
 * /params id of sensor
 */
function createHueTapRules(uniqueid, id) {

	var rule = '{';
	rule += '"name":"' + uniqueid + '[Rule1]",'; 
	rule += '"status":"enabled",';
	rule += '"actions":[{"address":"/groups/0/action","method":"PUT","body":{"on":false}}],';
	rule += '"conditions":[{"address":"/sensors/' + id + '/state/buttonevent","operator":"eq","value":"34"},{"address":"/sensors/' + id + '/state/lastupdated","operator":"dx"}]';
	rule += '}';

	createRuleRest(rule);
	
	rule = '{';
	rule += '"name":"' + uniqueid + '[Rule2]",'; 
	rule += '"status":"enabled",';
	rule += '"actions":[{"address":"/groups/0/action","method":"PUT","body":{"on":true}}],';
	rule += '"conditions":[{"address":"/sensors/' + id + '/state/buttonevent","operator":"eq","value":"16"},{"address":"/sensors/' + id + '/state/lastupdated","operator":"dx"}]';
	rule += '}';

	createRuleRest(rule);
	
	rule = '{';
	rule += '"name":"' + uniqueid + '[Rule3]",'; 
	rule += '"status":"enabled",';
	rule += '"actions":[{"address":"/groups/0/action","method":"PUT","body":{"on":true}}],';
	rule += '"conditions":[{"address":"/sensors/' + id + '/state/buttonevent","operator":"eq","value":"17"},{"address":"/sensors/' + id + '/state/lastupdated","operator":"dx"}]';
	rule += '}';

	createRuleRest(rule);
	
	rule = '{';
	rule += '"name":"' + uniqueid + '[Rule4]",'; 
	rule += '"status":"enabled",';
	rule += '"actions":[{"address":"/groups/0/action","method":"PUT","body":{"on":true}}],';
	rule += '"conditions":[{"address":"/sensors/' + id + '/state/buttonevent","operator":"eq","value":"18"},{"address":"/sensors/' + id + '/state/lastupdated","operator":"dx"}]';
	rule += '}';

	createRuleRest(rule);
	
}

/**
* api/<apikey>/sensors/<id>
*/
function loadDevice(id) {

    $.ajax({	
        url: 'api/' + apikey + '/sensors/' + id,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: '',
        success: function(json, status, xhr) {		
			curDevice = json;
			curDevice.id = id;
			
			config = JSON.parse(sessionStorage.config);
			var group;
			var groupIds = [];
			for (g in config.groups) {
				group = config.groups[g];
				if (group.devicemembership[0] == id) {
					groupIds[groupIds.length] = g;
				}
			}
			curDevice.groupIds = groupIds;
			
			loadRules();			

        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
              window.location.assign("/login.html");
              break;

            case 404: // not found go back
              window.location.assign("/");
              break;

            default:
              setTimeout(getDevices, 3000);
              showAlert('alert-error', '<b>Error!</b> Loading data, retry in three seconds ...');
              break;
            }
        },
		timeout: 10000
    });
}

/**
* api/<apikey>/rules
*/
function loadRules() {
var rule;
curRules = [];
    $.ajax({	
        url: 'api/' + apikey + '/rules',
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: '',
        success: function(json, status, xhr) {		
			for(key in json) {
				rule = json[key];
				rule.id = key;
				if(rule.conditions[0].address.indexOf("/sensors/" + curDevice.id + "/state/buttonevent") != -1) { //only for hue tap or other switches
					curRules[curRules.length] = rule;
				}
			}
			if (curDevice.type == "ZGPSwitch") {
				buildSubPageForTap();
			} else if (curDevice.type == "ZHASwitch") {
				buildSubPageForSwitch();
			}
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
              window.location.assign("/login.html");
              break;

            case 404: // not found go back
              window.location.assign("/");
              break;

            default:
              setTimeout(getDevices, 3000);
              showAlert('alert-error', '<b>Error!</b> Loading data, retry in three seconds ...');
              break;
            }
        },
		timeout: 10000
    });
}

/**
 * set rule parameter and call sendUpdateRuleRest()
 */
function updateRules() {
	var ruleId = ""; 
	var actionAddress = "";
	var actionBody = "";
	var sensorId = curDevice.id;
	
	// if name changed: update sensor name
	if (old.name != $('#devNameLabelBig').val()) {
		if ($('#devNameLabelBig').val() != "") {
			sendUpdateSensorName($('#devNameLabelBig').val())
		} else {
			showAlert('alert-error', '<b>Error!</b> Could not set empty device-name.');
			return;
		}
	}	
	
	if (curDevice.type == "ZHASwitch") {
		setTimeout(function(){window.open("devices.html","_self")},200);
		return;
	}
	
	if ($('#selectTarget0').val() != "X" && $('#selectTarget1').val() != "X" && $('#selectTarget2').val() != "X" && $('#selectTarget3').val() != "X" && $('#selectTarget0').val() != null && $('#selectTarget1').val() != null && $('#selectTarget2').val() != null && $('#selectTarget3').val() != null && $('#selectTarget0').val() != undefined && $('#selectTarget1').val() != undefined && $('#selectTarget2').val() != undefined && $('#selectTarget3').val() != undefined) {
		// if button 1 has changed: update rule 1
		if (old.selectTarget0 != $('#selectTarget0').val() || old.selectFunction0 != $('#selectFunction0').val()) {
			ruleId = curRules[0].id;
			if (($('#selectFunction0').val() == 1) || ($('#selectFunction0').val() == 2)) {
				actionAddress = "/groups/0/action";
				actionBody = ($('#selectFunction0').val() == 1) ? "\"on\":false" : "\"on\":true";
			} else if (($('#selectFunction0').val() == 3) || ($('#selectFunction0').val() == 4)) {
				var groupId = $('#selectTarget0').val();
				actionAddress = "/groups/" + groupId + "/action";
				actionBody = ($('#selectFunction0').val() == 3) ? "\"on\":false" : "\"on\":true";
			} else if ($('#selectFunction0').val() == 5) {
				var groupId = ($('#selectTarget0').val()).substring(0,($('#selectTarget0').val()).indexOf('-'));
				var sceneId = ($('#selectTarget0').val()).substring(($('#selectTarget0').val()).indexOf('-')+1,($('#selectTarget0').val()).length);
				actionAddress = "/groups/" + groupId + "/scenes/" + sceneId + "/recall";
			}
			sendUpdateRuleRest(ruleId, actionAddress, actionBody);
		}
		// if button 2 has changed: update rule 2
		if (old.selectTarget1 != $('#selectTarget1').val() || old.selectFunction1 != $('#selectFunction1').val()) {
			ruleId = curRules[1].id;
			if (($('#selectFunction1').val() == 1) || ($('#selectFunction1').val() == 2)) {
				actionAddress = "/groups/0/action";
				actionBody = ($('#selectFunction1').val() == 1) ? "\"on\":false" : "\"on\":true";
			} else if (($('#selectFunction1').val() == 3) || ($('#selectFunction1').val() == 4)) {
				var groupId = $('#selectTarget1').val();
				actionAddress = "/groups/" + groupId + "/action";
				actionBody = ($('#selectFunction10').val() == 3) ? "\"on\":false" : "\"on\":true";
			} else if ($('#selectFunction1').val() == 5) {
				var groupId = ($('#selectTarget1').val()).substring(0,($('#selectTarget1').val()).indexOf('-'));
				var sceneId = ($('#selectTarget1').val()).substring(($('#selectTarget1').val()).indexOf('-')+1,($('#selectTarget1').val()).length);
				actionAddress = "/groups/" + groupId + "/scenes/" + sceneId + "/recall";
			} 
			sendUpdateRuleRest(ruleId, actionAddress, actionBody);
		}
		// if button 3 has changed: update rule 3
		if (old.selectTarget2 != $('#selectTarget2').val() || old.selectFunction2 != $('#selectFunction2').val()) {
			ruleId = curRules[2].id;
			if (($('#selectFunction2').val() == 1) || ($('#selectFunction20').val() == 2)) {
				actionAddress = "/groups/0/action";
				actionBody = ($('#selectFunction2').val() == 1) ? "\"on\":false" : "\"on\":true";
			} else if (($('#selectFunction2').val() == 3) || ($('#selectFunction2').val() == 4)) {
				var groupId = $('#selectTarget2').val();
				actionAddress = "/groups/" + groupId + "/action";
				actionBody = ($('#selectFunction2').val() == 3) ? "\"on\":false" : "\"on\":true";
			} else if ($('#selectFunction2').val() == 5) {
				var groupId = ($('#selectTarget2').val()).substring(0,($('#selectTarget2').val()).indexOf('-'));
				var sceneId = ($('#selectTarget2').val()).substring(($('#selectTarget2').val()).indexOf('-')+1,($('#selectTarget2').val()).length);
				actionAddress = "/groups/" + groupId + "/scenes/" + sceneId + "/recall";
			} 
			sendUpdateRuleRest(ruleId, actionAddress, actionBody);
		}
		// if button 4 has changed: update rule 4
		if (old.selectTarget3 != $('#selectTarget3').val() || old.selectFunction3 != $('#selectFunction3').val()) {
			ruleId = curRules[3].id;
			if (($('#selectFunction3').val() == 1) || ($('#selectFunction3').val() == 2)) {
				actionAddress = "/groups/0/action";
				actionBody = ($('#selectFunction3').val() == 1) ? "\"on\":false" : "\"on\":true";
			} else if (($('#selectFunction3').val() == 3) || ($('#selectFunction3').val() == 4)) {
				var groupId = $('#selectTarget3').val();
				actionAddress = "/groups/" + groupId + "/action";
				actionBody = ($('#selectFunction3').val() == 3) ? "\"on\":false" : "\"on\":true";
			} else if ($('#selectFunction3').val() == 5) {
				var groupId = ($('#selectTarget3').val()).substring(0,($('#selectTarget3').val()).indexOf('-'));
				var sceneId = ($('#selectTarget3').val()).substring(($('#selectTarget3').val()).indexOf('-')+1,($('#selectTarget3').val()).length);
				actionAddress = "/groups/" + groupId + "/scenes/" + sceneId + "/recall";
			} 
			sendUpdateRuleRest(ruleId, actionAddress, actionBody);
		}
		setTimeout(function(){window.open("devices.html","_self")},200);
	} else {
		showAlert('alert-error', '<b>Error!</b> Could not set Scene or Group.');
	}
}

/**
 * PUT /api/<apikey>/rules/<id>
 */
function sendUpdateRuleRest(ruleId, actionAddress, actionBody) {
	var action = '{"actions":[{';
	action += '"address":"' + actionAddress + '",';
	action += '"method":"PUT",';
	action += '"body":{' + actionBody + '}}]}';
	
    $.ajax({
        url: '/api/' + apikey + '/rules/' +ruleId,
        type: 'PUT',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        data: action,
        dataType: 'json',
        success: function(data) {
        },
        error: function(jqXHR, textStatus, errorThrown) {
			//showAlert('alert-error', '<b>Error!</b> Could not set button configuration.');
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * POST /api/<apikey>/rules
 */
function createRuleRest(ruleData) {
    $.ajax({
        url: '/api/' + apikey + '/rules',
        type: 'POST',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        data: ruleData,
        dataType: 'json',
        success: function(data) {
        },
        error: function(jqXHR, textStatus, errorThrown) {
			//showAlert('alert-error', '<b>Error!</b> Could not set button configuration.');
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * PUT /api/<apikey>/sensors/<id>
 */
function sendUpdateSensorName(name) {
	var sensorId = getURLParameter('device');
    $.ajax({
        url: '/api/' + apikey + '/sensors/' + sensorId,
        type: 'PUT',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        data: '{"name":"' + name + '"}',
        dataType: 'json',
        success: function(data) {
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * DELETE /api/<apikey>/sensors/<id>
 */
function deleteSensor() {
	var id = curDevice.id
	
    $.ajax({
        url: '/api/' + apikey + '/sensors/' + id,
        type: 'DELETE',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function(data) {
			
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * DELETE /api/<apikey>/rules/<id>
 */
function deleteSensorRule(id) {	
    $.ajax({
        url: '/api/' + apikey + '/rules/' + id,
        type: 'DELETE',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function(data) {
			
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * DELETE /api/<apikey>/groups/<id>
 */
function deleteSensorGroup(id) {	
    $.ajax({
        url: '/api/' + apikey + '/groups/' + id,
        type: 'DELETE',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function(data) {
			
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * GET /api/<apikey>/sensors/<id>/groupidentifiers
 */
function getGroupIdentifiers() {
	var id = curDevice.id	
    $.ajax({
        url: '/api/' + apikey + '/sensors/' + id + '/groupidentifiers',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function(data) {
			console.log("get group identifiers success");
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

/**
 * Get all groups and scenes from configuration cache.
 * @return {bool} true if loaded from cache
 */
function getFullConfigurationCache() {
    if (Modernizr.sessionstorage) {
        if (sessionStorage.config) {
            var config = JSON.parse(sessionStorage.config);
			zigBeeChannel = config.config.zigbeechannel;
			
            for (gid in config.groups) {
				var group = config.groups[gid];
				allGroups[allGroups.length] = '<option value="'+ gid +'">'+ group.name +'</option>';
				for (sid in group.scenes) {
					var scene = group.scenes[sid]
					allScenes[allScenes.length] = '<option value="'+ gid + "-" + scene.id +'">'+ group.name +' - '+ scene.name + '</option>'; 
				}
			}
            return true;
        }
    }
    return false;
}

/**
 * Get all groups and scenes from configuration.
 */
function getFullConfiguration() {

    $.ajax({
        url: 'api/' + apikey,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        success: function(json, status, xhr) {
            config = json;
			zigBeeChannel = config.config.zigbeechannel;
			
            for (gid in config.groups) {
				var group = config.groups[gid];
				allGroups[allGroups.length] = '<option value="'+ gid +'">'+ group.name +'</option>';

				for (sid in group.scenes) {
					var scene = group.scenes[sid]
					allScenes[allScenes.length] = '<option value="'+ scene.id +'">'+ group.name +' - '+ scene.name + '</option>'; 
				}
			}
            // make available for caching
            if (Modernizr.sessionstorage) {
                sessionStorage.config = xhr.responseText;
            }
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                setTimeout(getFullConfiguration, 1000);
                //showAlert('alert-error', '<b>Error!</b> Lost connection, retry in one second ...');
                break;
            }
        },
        timeout: 10000
    });
}

/**
 * Helper Function to display Alerts
 */
function showAlert(alert, text, container) {
    if (typeof(container) === 'undefined') {
        container = '#alerts';
    }

    var d = new Date();
    var timestr = d.toUTCString();
    var txt = "";

    txt += '<div style="" class="alert ' + alert + '">';
    txt += text;
    txt += ' <span class="pull-right hidden-phone">';
    txt += '</span></div>';

	setTimeout(function() {	
		$(container).html(txt).scrollintoview();
	}, 250);
}

$(document).on('keydown', '.navbar-form #devNameLabelBig', function(event) {
	if(event.keyCode == 13) {
		if (event.target.nodeName === "INPUT") {
			isFocused = false;
            event.target.blur();
			event.preventDefault();
			return false;
		}
	}
});

/**
 * Select list click handler
 */
$(document).on('change', '.selectFunction', function(e) {
    var i = e.target.parentNode.parentNode.id;
	if ((e.target.value == "1") || (e.target.value == "2")) {		
		$('#selectTarget'+i).html('<option value="0">&#10003;</option>');
	} else if ((e.target.value == "3") || (e.target.value == "4")) {
		$('#selectTarget'+i).html("");
		if (allGroups.length === 0) {
			$('#selectTarget'+i).append("<option value=\"X\">No Group found</option>");
		} else {		
			for (option in allGroups) {
				$('#selectTarget'+i).append(allGroups[option]);
			}
		}
	} else if (e.target.value == "5") {	
		$('#selectTarget'+i).html("");
		if (allScenes.length === 0) {
			$('#selectTarget'+i).append("<option value=\"X\">No Scene found</option>");
		} else {
			for (option in allScenes) {
				$('#selectTarget'+i).append(allScenes[option]);
			}
		}
	}
});