var app = app || {};

function displayGroups(config) {

    var odd = false;
    var txtLeft = '<div class="span6">';
    var txtRight = '<div class="span6">';

    for (var id in config.groups) {
        var g = config.groups[id];

        var scenes = 'scenes';
        if (g.scenes.length == 1) {
            scenes = 'scene';
        }
		
		//var tempArray = [];
		var countLights = 0;
		for (l in g.lights) {
			//var uniqueId = config.lights[g.lights[l]].uniqueid;
			//var mac = uniqueId.substring(0,uniqueId.indexOf("-"));
			//if (!_.contains(tempArray,mac)) {
			//	tempArray[tempArray.length] = mac;
			//}
			var modelId = config.lights[g.lights[l]].modelid;
			if (modelId != "FLS-PP3 White") {
				countLights++;
			}
		}
		var deviceType = "";
		var deviceImage = "";
		
        var txt = '<h4>' + g.name + ' <small>' + countLights + ' lights, ' + g.scenes.length + ' ' + scenes + '</small></h4>';
        txt += '<div class="btn-toolbar">';
		if (Modernizr.localstorage && localStorage.getItem("de-gw-swVersion") != undefined) {
			var swVersion = localStorage.getItem("de-gw-swVersion");
			txt += '<a class="btn" href="edit_group_members.html?group=' + id + '&v=' + swVersion + '">Edit Members</a>';
		} else {
			txt += '<a class="btn" href="edit_group_members.html?group=' + id + '">Edit Members</a>';
		}
		if (config.sensors[g.devicemembership[0]] != undefined)
		{
			deviceType = config.sensors[g.devicemembership[0]].type; // TODO: use modelid
		}
		if (deviceType != "ZHASwitch") {
			txt += '<a class="btn btn-danger" href="#" onclick="showDeleteGroupModal(' + id + ');return false;">Delete</a>';
		}
        txt += '</div>';

        if (odd) {
            txtRight += txt;
        }
        else {
            txtLeft += txt;
        }
        odd = !odd;
    }

    txtLeft += '</div>';
    txtRight += '</div>';

    $('.groups').html(txtLeft + txtRight);
    app.config = config;
}

// get full configuration 
function getFullConfiguration() {

    $.ajax({
        url: 'api/' + apikey,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        //processData: false,
        success: function(json, status, xhr) {
            // make available for caching
            sessionStorage.config = xhr.responseText;
            clearAlert();
            displayGroups(json);
			clearUnusedLocalStorageKeys(json);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                setTimeout(getFullConfiguration, 1000);
                showAlert('alert-error', '<b>Error!</b> Lost connection, retry in one second ...');
                break;
            }
        },
        timeout: 8000
    });

}

function createGroup(name) {

    var out = { "name": name };

    $.ajax({
        url: 'api/' + apikey + '/groups',
        dataType: 'json',
        type: 'POST',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        //processData: false,
        data: JSON.stringify(out),
        success: function(json) {
            // force reload 
            sessionStorage.removeItem("config");
            location.reload(true);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
            //setTimeout(updateLights, 15000);
        }//,
        //timeout: 2000,
    });

}

function showDeleteGroupModal(id) {
    var name = "";

    if (app.config.groups) {
        var g = app.config.groups[id];
        name = g.name
    }

    $('#btnDeleteGroup').data('id', id);
    $('#deleteGroupModalLabel').html('Delete Group ' + name + '?');
    $('#deleteGroupModal').modal('show');
}

function deleteGroup(id) {
    $.ajax({
        url: 'api/' + apikey + '/groups/' + id,
        dataType: 'json',
        type: 'DELETE',
        cache: false,
        headers: { 'Accept': apiversion },
        //contentType: 'application/json; charset=utf-8',
        //processData: false,
        success: function(json) {
            // force reload 
            sessionStorage.removeItem("config");
			localStorage.removeItem("whitebarGroup-"+id);
            location.reload(true);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
            //setTimeout(updateLights, 15000);
        }//,
        //timeout: 2000,
    });
}

function clearUnusedLocalStorageKeys(config) {
	if (config != undefined) {
		// clear whitebar hidden status of deleted lights
		var lightIds = [];
		for (var lid in config.lights) {
			lightIds[lightIds.length] = lid;
		}
		for (var key in localStorage) {
			if (key.indexOf("whitebar-") != -1) {
				var id = key.substring(9, key.length);
				if (config != undefined && !_.contains(lightIds, id)) {
					localStorage.removeItem(key);
				}
			}
		}
		// clear whitebar hidden status of deleted groups
		var groupIds = [];
		for (var gid in config.groups) {
			groupIds[groupIds.length] = gid;
		}
		for (var key in localStorage) {
			if (key.indexOf("whitebarGroup-") != -1) {
				id = key.substring(14, key.length);
				if (config != undefined && !_.contains(groupIds, id)) {
					localStorage.removeItem(key);
				}
			}
			// clear visible status of deleted groups
			if (key.indexOf("visible-") != -1) {
				id = key.substring(8, key.length);
				if (config != undefined && !_.contains(groupIds, id)) {
					localStorage.removeItem(key);
				}
			}
		}
	}
}
